Index: trunk/src/VBox/Additions/WINNT/Graphics/Video/Makefile.kmk
===================================================================
--- trunk/src/VBox/Additions/WINNT/Graphics/Video/Makefile.kmk	(revision 75545)
+++ trunk/src/VBox/Additions/WINNT/Graphics/Video/Makefile.kmk	(revision 75566)
@@ -92,8 +92,10 @@
    	$(PATH_TARGET)/VBoxWddmCat.dir/VBoxNine.dll \
    	$(PATH_TARGET)/VBoxWddmCat.dir/VBoxSVGA.dll \
+   	$(PATH_TARGET)/VBoxWddmCat.dir/VBoxICD.dll \
    	$(PATH_TARGET)/VBoxWddmCat.dir/VBoxGL.dll
    VBoxWddm-inf_SOURCES.amd64 += \
    	$(PATH_TARGET)/VBoxWddmCat.dir/VBoxNine-x86.dll \
    	$(PATH_TARGET)/VBoxWddmCat.dir/VBoxSVGA-x86.dll \
+   	$(PATH_TARGET)/VBoxWddmCat.dir/VBoxICD-x86.dll \
    	$(PATH_TARGET)/VBoxWddmCat.dir/VBoxGL-x86.dll
   endif
@@ -156,4 +158,6 @@
   $(PATH_TARGET)/VBoxWddmCat.dir/VBoxSVGA.dll: $$(VBoxSVGA_1_TARGET) | $$(dir $$@)
 	$(INSTALL) -m 644 $< $(@D)
+  $(PATH_TARGET)/VBoxWddmCat.dir/VBoxICD.dll: $$(VBoxICD_1_TARGET) | $$(dir $$@)
+	$(INSTALL) -m 644 $< $(@D)
   $(PATH_TARGET)/VBoxWddmCat.dir/VBoxGL.dll: $$(VBoxGL_1_TARGET) | $$(dir $$@)
 	$(INSTALL) -m 644 $< $(@D)
@@ -163,4 +167,6 @@
 	$(INSTALL) -m 644 $< $(@D)
    $(PATH_TARGET)/VBoxWddmCat.dir/VBoxSVGA-x86.dll: $$(VBoxSVGA-x86_1_TARGET) | $$(dir $$@)
+	$(INSTALL) -m 644 $< $(@D)
+   $(PATH_TARGET)/VBoxWddmCat.dir/VBoxICD-x86.dll: $$(VBoxICD-x86_1_TARGET) | $$(dir $$@)
 	$(INSTALL) -m 644 $< $(@D)
    $(PATH_TARGET)/VBoxWddmCat.dir/VBoxGL-x86.dll: $$(VBoxGL-x86_1_TARGET) | $$(dir $$@)
@@ -235,8 +241,10 @@
 			$(PATH_TARGET)/VBoxWddmCat.dir/VBoxNine.dll \
 			$(PATH_TARGET)/VBoxWddmCat.dir/VBoxSVGA.dll \
+			$(PATH_TARGET)/VBoxWddmCat.dir/VBoxICD.dll \
 			$(PATH_TARGET)/VBoxWddmCat.dir/VBoxGL.dll \
 			$(if-expr "$(KBUILD_TARGET_ARCH)" == "amd64", \
 				$(PATH_TARGET)/VBoxWddmCat.dir/VBoxNine-x86.dll \
 				$(PATH_TARGET)/VBoxWddmCat.dir/VBoxSVGA-x86.dll \
+				$(PATH_TARGET)/VBoxWddmCat.dir/VBoxICD-x86.dll \
 				$(PATH_TARGET)/VBoxWddmCat.dir/VBoxGL-x86.dll, ), ) \
 		$(if $(VBOXWDDM_WITH_GL),  $(PATH_TARGET)/VBoxWddmCat.dir/VBoxOGL.dll \
Index: trunk/src/VBox/Additions/WINNT/Graphics/Video/mp/wddm/VBoxWddm.inf
===================================================================
--- trunk/src/VBox/Additions/WINNT/Graphics/Video/mp/wddm/VBoxWddm.inf	(revision 75545)
+++ trunk/src/VBox/Additions/WINNT/Graphics/Video/mp/wddm/VBoxWddm.inf	(revision 75566)
@@ -57,4 +57,5 @@
 ;mesa3d VBoxNine.dll,,,0x00004000     ; COPYFLG_IN_USE_TRY_RENAME
 ;mesa3d VBoxSVGA.dll,,,0x00004000     ; COPYFLG_IN_USE_TRY_RENAME
+;mesa3d VBoxICD.dll,,,0x00004000      ; COPYFLG_IN_USE_TRY_RENAME
 ;mesa3d VBoxGL.dll,,,0x00004000       ; COPYFLG_IN_USE_TRY_RENAME
 
@@ -63,4 +64,5 @@
 ;amd64 ;mesa3d VBoxNine-x86.dll,,,0x00004000     ; COPYFLG_IN_USE_TRY_RENAME
 ;amd64 ;mesa3d VBoxSVGA-x86.dll,,,0x00004000     ; COPYFLG_IN_USE_TRY_RENAME
+;amd64 ;mesa3d VBoxICD-x86.dll,,,0x00004000      ; COPYFLG_IN_USE_TRY_RENAME
 ;amd64 ;mesa3d VBoxGL-x86.dll,,,0x00004000       ; COPYFLG_IN_USE_TRY_RENAME
 
@@ -91,6 +93,6 @@
 ;dispd3d HKR,, UserModeDriverName,    %REG_MULTI_SZ%, VBoxDispD3D.dll
 ;amd64 ;dispd3d HKR,, UserModeDriverNameWow,    %REG_MULTI_SZ%, VBoxDispD3D-x86.dll
-;icd        HKR,, OpenGLDriverName,    %REG_MULTI_SZ%, VBoxOGL.dll
-;amd64 ;icd HKR,, OpenGLDriverNameWoW, %REG_MULTI_SZ%, VBoxOGL-x86.dll
+;icd        HKR,, OpenGLDriverName,    %REG_MULTI_SZ%, VBoxICD
+;amd64 ;icd HKR,, OpenGLDriverNameWoW, %REG_MULTI_SZ%, VBoxICD-x86
 ;icd        HKR,, OpenGLFlags,         %REG_DWORD%,    0x00000001
 ;amd64 ;icd HKR,, OpenGLFlagsWoW,      %REG_DWORD%,    0x00000001
@@ -127,8 +129,10 @@
 ;amd64 ;mesa3d VBoxNine-x86.dll = 1
 ;amd64 ;mesa3d VBoxSVGA-x86.dll = 1
+;amd64 ;mesa3d VBoxICD-x86.dll = 1
 ;amd64 ;mesa3d VBoxGL-x86.dll = 1
 ;dispd3d VBoxDispD3D.dll = 1
 ;mesa3d VBoxNine.dll = 1
 ;mesa3d VBoxSVGA.dll = 1
+;mesa3d VBoxICD.dll = 1
 ;mesa3d VBoxGL.dll = 1
 ;amd64 ;gl VBoxOGL-x86.dll = 1
Index: trunk/src/VBox/Additions/WINNT/Installer/Makefile.kmk
===================================================================
--- trunk/src/VBox/Additions/WINNT/Installer/Makefile.kmk	(revision 75545)
+++ trunk/src/VBox/Additions/WINNT/Installer/Makefile.kmk	(revision 75566)
@@ -138,4 +138,5 @@
 	$(PATH_STAGE_BIN)/additions/VBoxNine.dll \
 	$(PATH_STAGE_BIN)/additions/VBoxSVGA.dll \
+	$(PATH_STAGE_BIN)/additions/VBoxICD.dll \
 	$(PATH_STAGE_BIN)/additions/VBoxGL.dll
  endif
@@ -156,4 +157,5 @@
 	$(PATH_STAGE_BIN)/additions/VBoxNine-x86.dll \
 	$(PATH_STAGE_BIN)/additions/VBoxSVGA-x86.dll \
+	$(PATH_STAGE_BIN)/additions/VBoxICD-x86.dll \
 	$(PATH_STAGE_BIN)/additions/VBoxGL-x86.dll
   endif
Index: trunk/src/VBox/Additions/WINNT/Installer/VBoxGuestAdditionsCommon.nsh
===================================================================
--- trunk/src/VBox/Additions/WINNT/Installer/VBoxGuestAdditionsCommon.nsh	(revision 75545)
+++ trunk/src/VBox/Additions/WINNT/Installer/VBoxGuestAdditionsCommon.nsh	(revision 75566)
@@ -110,4 +110,5 @@
     FILE "$%PATH_OUT%\bin\additions\VBoxNine.dll"
     FILE "$%PATH_OUT%\bin\additions\VBoxSVGA.dll"
+    FILE "$%PATH_OUT%\bin\additions\VBoxICD.dll"
     FILE "$%PATH_OUT%\bin\additions\VBoxGL.dll"
   !endif
@@ -131,4 +132,5 @@
       FILE "$%PATH_OUT%\bin\additions\VBoxNine-x86.dll"
       FILE "$%PATH_OUT%\bin\additions\VBoxSVGA-x86.dll"
+      FILE "$%PATH_OUT%\bin\additions\VBoxICD-x86.dll"
       FILE "$%PATH_OUT%\bin\additions\VBoxGL-x86.dll"
     !endif
Index: trunk/src/VBox/Additions/WINNT/Installer/VBoxGuestAdditionsW2KXP.nsh
===================================================================
--- trunk/src/VBox/Additions/WINNT/Installer/VBoxGuestAdditionsW2KXP.nsh	(revision 75545)
+++ trunk/src/VBox/Additions/WINNT/Installer/VBoxGuestAdditionsW2KXP.nsh	(revision 75566)
@@ -243,4 +243,5 @@
       FILE "$%PATH_OUT%\bin\additions\VBoxNine.dll"
       FILE "$%PATH_OUT%\bin\additions\VBoxSVGA.dll"
+      FILE "$%PATH_OUT%\bin\additions\VBoxICD.dll"
       FILE "$%PATH_OUT%\bin\additions\VBoxGL.dll"
     !endif
@@ -264,4 +265,5 @@
         FILE "$%PATH_OUT%\bin\additions\VBoxNine-x86.dll"
         FILE "$%PATH_OUT%\bin\additions\VBoxSVGA-x86.dll"
+        FILE "$%PATH_OUT%\bin\additions\VBoxICD-x86.dll"
         FILE "$%PATH_OUT%\bin\additions\VBoxGL-x86.dll"
       !endif
@@ -538,4 +540,5 @@
     Delete /REBOOTOK "$%PATH_OUT%\bin\additions\VBoxNine.dll"
     Delete /REBOOTOK "$%PATH_OUT%\bin\additions\VBoxSVGA.dll"
+    Delete /REBOOTOK "$%PATH_OUT%\bin\additions\VBoxICD.dll"
     Delete /REBOOTOK "$%PATH_OUT%\bin\additions\VBoxGL.dll"
   !endif
@@ -559,4 +562,5 @@
       Delete /REBOOTOK "$%PATH_OUT%\bin\additions\VBoxNine-x86.dll"
       Delete /REBOOTOK "$%PATH_OUT%\bin\additions\VBoxSVGA-x86.dll"
+      Delete /REBOOTOK "$%PATH_OUT%\bin\additions\VBoxICD-x86.dll"
       Delete /REBOOTOK "$%PATH_OUT%\bin\additions\VBoxGL-x86.dll"
     !endif
@@ -632,4 +636,5 @@
     Delete /REBOOTOK "$g_strSystemDir\VBoxNine.dll"
     Delete /REBOOTOK "$g_strSystemDir\VBoxSVGA.dll"
+    Delete /REBOOTOK "$g_strSystemDir\VBoxICD.dll"
     Delete /REBOOTOK "$g_strSystemDir\VBoxGL.dll"
   !endif