Index: trunk/include/VBox/hgcmsvc.h
===================================================================
--- trunk/include/VBox/hgcmsvc.h	(revision 75784)
+++ trunk/include/VBox/hgcmsvc.h	(revision 75792)
@@ -205,5 +205,5 @@
 
 /** Extract an uint32_t value from an HGCM parameter structure. */
-DECLINLINE(int) HGCMSvcGetU32(struct VBOXHGCMSVCPARM *pParm, uint32_t *pu32)
+DECLINLINE(int) HGCMSvcGetU32(VBOXHGCMSVCPARM *pParm, uint32_t *pu32)
 {
     int rc = VINF_SUCCESS;
@@ -219,5 +219,5 @@
 
 /** Extract an uint64_t value from an HGCM parameter structure. */
-DECLINLINE(int) HGCMSvcGetU64(struct VBOXHGCMSVCPARM *pParm, uint64_t *pu64)
+DECLINLINE(int) HGCMSvcGetU64(VBOXHGCMSVCPARM *pParm, uint64_t *pu64)
 {
     int rc = VINF_SUCCESS;
@@ -233,6 +233,5 @@
 
 /** Extract an pointer value from an HGCM parameter structure. */
-DECLINLINE(int) HGCMSvcGetPv(struct VBOXHGCMSVCPARM *pParm, void **ppv,
-                               uint32_t *pcb)
+DECLINLINE(int) HGCMSvcGetPv(VBOXHGCMSVCPARM *pParm, void **ppv, uint32_t *pcb)
 {
     AssertPtrReturn(pParm, VERR_INVALID_POINTER);
@@ -250,6 +249,5 @@
 
 /** Extract a constant pointer value from an HGCM parameter structure. */
-DECLINLINE(int) HGCMSvcGetPcv(struct VBOXHGCMSVCPARM *pParm, const void **ppv,
-                                uint32_t *pcb)
+DECLINLINE(int) HGCMSvcGetPcv(VBOXHGCMSVCPARM *pParm, const void **ppv, uint32_t *pcb)
 {
     AssertPtrReturn(pParm, VERR_INVALID_POINTER);
@@ -268,6 +266,5 @@
 /** Extract a valid pointer to a non-empty buffer from an HGCM parameter
  * structure. */
-DECLINLINE(int) HGCMSvcGetBuf(struct VBOXHGCMSVCPARM *pParm, void **ppv,
-                                uint32_t *pcb)
+DECLINLINE(int) HGCMSvcGetBuf(VBOXHGCMSVCPARM *pParm, void **ppv, uint32_t *pcb)
 {
     AssertPtrReturn(pParm, VERR_INVALID_POINTER);
@@ -288,6 +285,5 @@
 /** Extract a valid pointer to a non-empty constant buffer from an HGCM
  * parameter structure. */
-DECLINLINE(int) HGCMSvcGetCBuf(struct VBOXHGCMSVCPARM *pParm,
-                                 const void **ppv, uint32_t *pcb)
+DECLINLINE(int) HGCMSvcGetCBuf(VBOXHGCMSVCPARM *pParm, const void **ppv, uint32_t *pcb)
 {
     AssertPtrReturn(pParm, VERR_INVALID_POINTER);
@@ -307,6 +303,5 @@
 
 /** Extract a string value from an HGCM parameter structure. */
-DECLINLINE(int) HGCMSvcGetStr(struct VBOXHGCMSVCPARM *pParm, char **ppch,
-                                uint32_t *pcb)
+DECLINLINE(int) HGCMSvcGetStr(VBOXHGCMSVCPARM *pParm, char **ppch, uint32_t *pcb)
 {
     AssertPtrReturn(pParm, VERR_INVALID_POINTER);
@@ -331,6 +326,5 @@
 
 /** Extract a constant string value from an HGCM parameter structure. */
-DECLINLINE(int) HGCMSvcGetCStr(struct VBOXHGCMSVCPARM *pParm,
-                                 const char **ppch, uint32_t *pcb)
+DECLINLINE(int) HGCMSvcGetCStr(VBOXHGCMSVCPARM *pParm, const char **ppch, uint32_t *pcb)
 {
     AssertPtrReturn(pParm, VERR_INVALID_POINTER);
@@ -355,6 +349,5 @@
 
 /** Extract a constant string value from an HGCM parameter structure. */
-DECLINLINE(int) HGCMSvcGetPsz(struct VBOXHGCMSVCPARM *pParm, const char **ppch,
-                                uint32_t *pcb)
+DECLINLINE(int) HGCMSvcGetPsz(VBOXHGCMSVCPARM *pParm, const char **ppch, uint32_t *pcb)
 {
     AssertPtrReturn(pParm, VERR_INVALID_POINTER);
@@ -379,5 +372,5 @@
 
 /** Set a uint32_t value to an HGCM parameter structure */
-DECLINLINE(void) HGCMSvcSetU32(struct VBOXHGCMSVCPARM *pParm, uint32_t u32)
+DECLINLINE(void) HGCMSvcSetU32(VBOXHGCMSVCPARM *pParm, uint32_t u32)
 {
     AssertPtr(pParm);
@@ -387,5 +380,5 @@
 
 /** Set a uint64_t value to an HGCM parameter structure */
-DECLINLINE(void) HGCMSvcSetU64(struct VBOXHGCMSVCPARM *pParm, uint64_t u64)
+DECLINLINE(void) HGCMSvcSetU64(VBOXHGCMSVCPARM *pParm, uint64_t u64)
 {
     AssertPtr(pParm);
@@ -395,6 +388,5 @@
 
 /** Set a pointer value to an HGCM parameter structure */
-DECLINLINE(void) HGCMSvcSetPv(struct VBOXHGCMSVCPARM *pParm, void *pv,
-                                uint32_t cb)
+DECLINLINE(void) HGCMSvcSetPv(VBOXHGCMSVCPARM *pParm, void *pv, uint32_t cb)
 {
     AssertPtr(pParm);
@@ -405,5 +397,5 @@
 
 /** Set a pointer value to an HGCM parameter structure */
-DECLINLINE(void) HGCMSvcSetStr(struct VBOXHGCMSVCPARM *pParm, const char *psz)
+DECLINLINE(void) HGCMSvcSetStr(VBOXHGCMSVCPARM *pParm, const char *psz)
 {
     AssertPtr(pParm);
@@ -416,6 +408,5 @@
 # ifdef ___iprt_cpp_ministring_h
 /** Set a const string value to an HGCM parameter structure */
-DECLINLINE(void) HGCMSvcSetRTCStr(struct VBOXHGCMSVCPARM *pParm,
-                                    const RTCString &rString)
+DECLINLINE(void) HGCMSvcSetRTCStr(VBOXHGCMSVCPARM *pParm, const RTCString &rString)
 {
     AssertPtr(pParm);