Index: trunk/src/VBox/Main/idl/VirtualBox.xidl
===================================================================
--- trunk/src/VBox/Main/idl/VirtualBox.xidl	(revision 75920)
+++ trunk/src/VBox/Main/idl/VirtualBox.xidl	(revision 75926)
@@ -4870,5 +4870,5 @@
   <interface
     name="IRecordingScreenSettings" extends="$unknown"
-    uuid="B036627B-9922-4056-8A95-94C60D3BA48A"
+    uuid="678fbd9a-93af-42a7-7f13-79ad6ef1a18d"
     wsmap="managed"
     >
@@ -4913,5 +4913,5 @@
     </attribute>
 
-    <attribute name="fileName" type="wstring">
+    <attribute name="filename" type="wstring">
       <desc>
         This setting determines the filename VirtualBox uses to save
@@ -13947,5 +13947,5 @@
   <interface
     name="IFile" extends="$unknown"
-    uuid="5395b543-0ee9-4d6a-9ecd-580e3a1d0dbb"
+    uuid="59a235ac-2f1a-4d6c-81fc-e3fa843f49ae"
     wsmap="managed"
     reservedMethods="4" reservedAttributes="8"
@@ -13992,5 +13992,5 @@
     <!-- The following attributes just remembers the fileOpen parameters for you.
          Nice for introspection and probably doesn't cost us much. -->
-    <attribute name="fileName" type="wstring" readonly="yes">
+    <attribute name="filename" type="wstring" readonly="yes">
       <desc>Full path of the actual file name of this file.
         <!-- r=bird: The 'actual' file name is too tough, we cannot guarentee
@@ -14205,5 +14205,5 @@
   <interface
     name="IFsObjInfo" extends="$unknown"
-    uuid="ae34e3d5-f884-4141-8d62-618300658805"
+    uuid="081fc833-c6fa-430e-6020-6a505d086387"
     wsmap="managed"
     reservedAttributes="8"
@@ -14213,28 +14213,12 @@
       This can be information about a file or a directory, for example.
     </desc>
-
-    <attribute name="accessTime" type="long long" readonly="yes">
-      <desc>
-        Time of last access (st_atime).
-      </desc>
-    </attribute>
-    <attribute name="allocatedSize" type="long long" readonly="yes">
-      <desc>
-        Disk allocation size (st_blocks * DEV_BSIZE).
-      </desc>
-    </attribute>
-    <attribute name="birthTime" type="long long" readonly="yes">
-      <desc>
-        Time of file birth (st_birthtime).
-      </desc>
-    </attribute>
-        <attribute name="changeTime" type="long long" readonly="yes">
-      <desc>
-        Time of last status change (st_ctime).
-      </desc>
-    </attribute>
-    <attribute name="deviceNumber" type="unsigned long" readonly="yes">
-      <desc>
-        The device number of a character or block device type object (st_rdev).
+    <attribute name="name" type="wstring" readonly="yes">
+      <desc>
+        The object's name.
+      </desc>
+    </attribute>
+    <attribute name="type" type="FsObjType" readonly="yes">
+      <desc>
+        The object type. See <link to="FsObjType" /> for more.
       </desc>
     </attribute>
@@ -14242,44 +14226,4 @@
       <desc>
         File attributes. Not implemented yet.
-      </desc>
-    </attribute>
-    <attribute name="generationId" type="unsigned long" readonly="yes">
-      <desc>
-        The current generation number (st_gen).
-      </desc>
-    </attribute>
-    <attribute name="GID" type="unsigned long" readonly="yes">
-      <desc>
-        The group the filesystem object is assigned (st_gid).
-      </desc>
-    </attribute>
-    <attribute name="groupName" type="wstring" readonly="yes">
-      <desc>
-        The group name.
-      </desc>
-    </attribute>
-    <attribute name="hardLinks" type="unsigned long" readonly="yes">
-      <desc>
-        Number of hard links to this filesystem object (st_nlink).
-      </desc>
-    </attribute>
-    <attribute name="modificationTime" type="long long" readonly="yes">
-      <desc>
-        Time of last data modification (st_mtime).
-      </desc>
-    </attribute>
-    <attribute name="name" type="wstring" readonly="yes">
-      <desc>
-        The object's name.
-      </desc>
-    </attribute>
-    <attribute name="nodeId" type="long long" readonly="yes">
-      <desc>
-        The unique identifier (within the filesystem) of this filesystem object (st_ino).
-      </desc>
-    </attribute>
-    <attribute name="nodeIdDevice" type="unsigned long" readonly="yes">
-      <desc>
-        The device number of the device which this filesystem object resides on (st_dev).
       </desc>
     </attribute>
@@ -14291,12 +14235,76 @@
       </desc>
     </attribute>
-    <attribute name="type" type="FsObjType" readonly="yes">
-      <desc>
-        The object type. See <link to="FsObjType" /> for more.
-      </desc>
-    </attribute>
-    <attribute name="UID" type="unsigned long" readonly="yes">
-      <desc>
-        The user owning the filesystem object (st_uid).
+    <attribute name="allocatedSize" type="long long" readonly="yes">
+      <desc>
+        Disk allocation size (st_blocks * DEV_BSIZE).
+      </desc>
+    </attribute>
+    <!-- Time attributes: -->
+    <attribute name="accessTime" type="long long" readonly="yes">
+      <desc>
+        Time of last access (st_atime).
+      </desc>
+    </attribute>
+    <attribute name="birthTime" type="long long" readonly="yes">
+      <desc>
+        Time of file birth (st_birthtime).
+      </desc>
+    </attribute>
+    <attribute name="changeTime" type="long long" readonly="yes">
+      <desc>
+        Time of last status change (st_ctime).
+      </desc>
+    </attribute>
+    <attribute name="modificationTime" type="long long" readonly="yes">
+      <desc>
+        Time of last data modification (st_mtime).
+      </desc>
+    </attribute>
+    <!-- Ownership attributes: -->
+    <attribute name="UID" type="long" readonly="yes">
+      <desc>
+        The user owning the filesystem object (st_uid).  This is -1 if not available.
+      </desc>
+    </attribute>
+    <attribute name="userName" type="wstring" readonly="yes">
+      <desc>
+        The user name.
+      </desc>
+    </attribute>
+    <attribute name="GID" type="long" readonly="yes">
+      <desc>
+        The group the filesystem object is assigned (st_gid).  This is -1 if not available.
+      </desc>
+    </attribute>
+    <attribute name="groupName" type="wstring" readonly="yes">
+      <desc>
+        The group name.
+      </desc>
+    </attribute>
+    <!-- More esoteric attributes: -->
+    <attribute name="nodeId" type="long long" readonly="yes">
+      <desc>
+        The unique identifier (within the filesystem) of this filesystem object (st_ino).
+        This is zero if not availalbe.
+      </desc>
+    </attribute>
+    <attribute name="nodeIdDevice" type="unsigned long" readonly="yes">
+      <desc>
+        The device number of the device which this filesystem object resides on (st_dev).
+      </desc>
+    </attribute>
+    <attribute name="hardLinks" type="unsigned long" readonly="yes">
+      <desc>
+        Number of hard links to this filesystem object (st_nlink).
+      </desc>
+    </attribute>
+    <attribute name="deviceNumber" type="unsigned long" readonly="yes">
+      <desc>
+        The device number of a character or block device type object (st_rdev).
+      </desc>
+    </attribute>
+    <attribute name="generationId" type="unsigned long" readonly="yes">
+      <desc>
+        The current generation number (st_gen).
       </desc>
     </attribute>
@@ -14306,10 +14314,4 @@
       </desc>
     </attribute>
-    <attribute name="userName" type="wstring" readonly="yes">
-      <desc>
-        The user name.
-      </desc>
-    </attribute>
-
   </interface>
 