Index: trunk/include/VBox/err.mac
===================================================================
--- trunk/include/VBox/err.mac	(revision 75992)
+++ trunk/include/VBox/err.mac	(revision 75994)
@@ -6,5 +6,5 @@
 
 ;
-; Copyright (C) 2006-2017 Oracle Corporation
+; Copyright (C) 2006-2018 Oracle Corporation
 ;
 ; This file is part of VirtualBox Open Source Edition (OSE), as
@@ -51,4 +51,5 @@
 %define VERR_RAW_MODE_NOT_SUPPORTED    (-1023)
 %define VERR_INCONSISTENT_VM_HANDLE    (-1024)
+%define VERR_VM_RESTORED    (-1025)
 %define VINF_EM_FIRST    1100
 %define VINF_EM_TERMINATE    1100
@@ -92,5 +93,4 @@
 %define VINF_EM_RAW_STALE_SELECTOR    1138
 %define VINF_EM_RAW_IRET_TRAP    1139
-%define VINF_EM_RAW_EMULATE_IO_BLOCK    1140
 %define VERR_EM_INTERPRETER    (-1148)
 %define VERR_EM_INTERNAL_ERROR    (-1149)
@@ -103,4 +103,7 @@
 %define VINF_EM_RAW_INJECT_TRPM_EVENT    1157
 %define VERR_EM_GUEST_CPU_HANG    (-1158)
+%define VINF_EM_PENDING_R3_IOPORT_READ    1159
+%define VINF_EM_PENDING_R3_IOPORT_WRITE    1160
+%define VINF_EM_RESUME_R3_HISTORY_EXEC    1161
 %define VERR_DBGF_NOT_ATTACHED    (-1200)
 %define VERR_DBGF_ALREADY_ATTACHED    (-1201)
@@ -242,4 +245,6 @@
 %define VERR_PGM_PHYS_PAGE_MAP_MMIO2_IPE    (-1684)
 %define VERR_PGM_PHYS_MMIO_EX_IPE    (-1685)
+%define VERR_PGM_MODE_IPE    (-1686)
+%define VERR_PGM_SHW_NONE_IPE    (-1687)
 %define VERR_MM_RAM_CONFLICT    (-1700)
 %define VERR_MM_HYPER_NO_MEMORY    (-1701)
@@ -262,4 +267,6 @@
 %define VERR_CPUM_INVALID_XCR0    (-1765)
 %define VINF_CPUM_HOST_CR0_MODIFIED    (1766)
+%define VERR_CPUM_INVALID_HWVIRT_CONFIG    (-1767)
+%define VERR_CPUM_INVALID_HWVIRT_FEAT_COMBO    (-1768)
 %define VERR_SSM_UNIT_EXISTS    (-1800)
 %define VERR_SSM_UNIT_NOT_FOUND    (-1801)
@@ -470,4 +477,5 @@
 %define VERR_VMM_WRONG_HM_VMCPU_STATE    (-2716)
 %define VERR_VMM_SMAP_BUT_AC_CLEAR    (-2717)
+%define VERR_VMM_WRONG_NEM_VMCPU_STATE    (-2718)
 %define VERR_PDM_NO_SUCH_LUN    (-2800)
 %define VERR_PDM_DEVINS_UNKNOWN_CFG_VALUES    (-2801)
@@ -719,4 +727,5 @@
 %define VERR_SUPDRV_NOT_BUDDING_VM_PROCESS_1    (-3748)
 %define VERR_SUPDRV_NOT_BUDDING_VM_PROCESS_2    (-3749)
+%define VERR_SUPDRV_NO_RAW_MODE_HYPER_V_ROOT    (-7000)
 %define VERR_SUPLIB_PATH_NOT_ABSOLUTE    (-3750)
 %define VERR_SUPLIB_PATH_NOT_CLEAN    (-3751)
@@ -791,7 +800,6 @@
 %define VERR_VMX_UNABLE_TO_START_VM    (-4005)
 %define VERR_VMX_INVALID_HOST_STATE    (-4006)
-%define VERR_VMX_ILLEGAL_FEATURE_CONTROL_MSR    (-4007)
-%define VERR_VMX_UNSUPPORTED_MODE    (-4008)
 %define VERR_VMX_NO_VMX    (-4009)
+%define VERR_VMX_NOT_SUPPORTED    (-4010)
 %define VERR_VMX_IN_VMX_ROOT_MODE    (-4011)
 %define VERR_VMX_X86_CR4_VMXE_CLEARED    (-4012)
@@ -812,11 +820,12 @@
 %define VERR_VMX_MSR_ALL_VMX_DISABLED    (-4028)
 %define VERR_VMX_MSR_VMX_DISABLED    (-4029)
-%define VERR_VMX_ENTRY_CTLS_CACHE_INVALID    (-4030)
-%define VERR_VMX_EXIT_CTLS_CACHE_INVALID    (-4031)
-%define VERR_VMX_PIN_EXEC_CTLS_CACHE_INVALID    (-4032)
-%define VERR_VMX_PROC_EXEC_CTLS_CACHE_INVALID    (-4033)
-%define VERR_VMX_PROC_EXEC2_CTLS_CACHE_INVALID    (-4034)
-%define VERR_VMX_MSR_VMX_ENABLE_FAILED    (-4035)
-%define VERR_VMX_MSR_SMX_VMX_ENABLE_FAILED    (-4036)
+%define VERR_VMX_VMCS_FIELD_CACHE_INVALID    (-4030)
+%define VERR_VMX_MSR_VMX_ENABLE_FAILED    (-4031)
+%define VERR_VMX_MSR_SMX_VMX_ENABLE_FAILED    (-4032)
+%define VINF_VMX_VMEXIT    4033
+%define VERR_VMX_VMENTRY_FAILED    (-4033)
+%define VERR_VMX_VMEXIT_FAILED    (-4034)
+%define VINF_VMX_INTERCEPT_NOT_ACTIVE    4035
+%define VINF_VMX_MODIFIES_BEHAVIOR    4036
 %define VERR_SVM_UNABLE_TO_START_VM    (-4050)
 %define VERR_SVM_ILLEGAL_EFER_MSR    (-4051)
@@ -838,4 +847,5 @@
 %define VINF_SVM_VMEXIT    4067
 %define VINF_SVM_VMRUN    4068
+%define VINF_SVM_INTERCEPT_NOT_ACTIVE    4069
 %define VERR_HM_UNKNOWN_CPU    (-4100)
 %define VERR_HM_NO_CPUID    (-4101)
@@ -856,5 +866,5 @@
 %define VERR_HM_INVALID_HM64ON32OP    (-4116)
 %define VINF_HM_DOUBLE_FAULT    4117
-%define VINF_HM_INTERCEPT_NOT_ACTIVE    4118
+%define VINF_HM_PENDING_XCPT    4118
 %define VERR_DIS_INVALID_OPCODE    (-4200)
 %define VERR_DIS_GEN_FAILURE    (-4201)
@@ -1039,5 +1049,6 @@
 %define VWRN_GSTCTL_OBJECTSTATE_CHANGED    6220
 %define VERR_GSTCTL_PROCESS_WRONG_STATE    (-6221)
-%define VWRN_GSTCTL_PROCESS_EXIT_CODE    6221
+%define VERR_GSTCTL_MAX_OBJECTS_REACHED    (-6222)
+%define VERR_GSTCTL_PROCESS_EXIT_CODE    (-6223)
 %define VERR_GIM_NOT_ENABLED    (-6300)
 %define VERR_GIM_IPE_1    (-6301)
@@ -1063,10 +1074,45 @@
 %define VERR_GSTDND_GUEST_ERROR    (-6500)
 %define VERR_AUDIO_BACKEND_INIT_FAILED    (-6600)
-%define VERR_AUDIO_NO_FREE_INPUT_STREAMS    (-6601)
-%define VERR_AUDIO_NO_FREE_OUTPUT_STREAMS    (-6602)
-%define VERR_AUDIO_STREAM_PENDING_DISABLE    (-6603)
-%define VINF_AUDIO_MORE_DATA_AVAILABLE    (6604)
+%define VERR_AUDIO_BACKEND_NOT_ATTACHED    (-6601)
+%define VERR_AUDIO_NO_FREE_INPUT_STREAMS    (-6602)
+%define VERR_AUDIO_NO_FREE_OUTPUT_STREAMS    (-6603)
+%define VERR_AUDIO_STREAM_PENDING_DISABLE    (-6604)
+%define VINF_AUDIO_MORE_DATA_AVAILABLE    (6605)
+%define VERR_AUDIO_STREAM_NOT_READY    (-6605)
+%define VERR_AUDIO_STREAM_COULD_NOT_CREATE    (-6606)
 %define VERR_APIC_INTR_NOT_PENDING    (-6700)
 %define VERR_APIC_INTR_MASKED_BY_TPR    (-6701)
 %define VERR_APIC_INTR_DISCARDED    (-6702)
+%define VERR_NEM_NOT_ENABLED    (-6800)
+%define VERR_NEM_NOT_AVAILABLE    (-6801)
+%define VERR_NEM_INIT_FAILED    (-6802)
+%define VERR_NEM_MISSING_KERNEL_API    (-6803)
+%define VERR_NEM_RING3_ONLY    (-6804)
+%define VERR_NEM_VM_CREATE_FAILED    (-6805)
+%define VERR_NEM_MAP_PAGES_FAILED    (-6806)
+%define VERR_NEM_UNMAP_PAGES_FAILED    (-6807)
+%define VERR_NEM_GET_REGISTERS_FAILED    (-6808)
+%define VERR_NEM_SET_REGISTERS_FAILED    (-6809)
+%define VERR_NEM_FLUSH_TLB    (-6810)
+%define VINF_NEM_FLUSH_TLB    (6810)
+%define VERR_NEM_SET_TSC    (-6811)
+%define VERR_NEM_IPE_0    (-6890)
+%define VERR_NEM_IPE_1    (-6891)
+%define VERR_NEM_IPE_2    (-6892)
+%define VERR_NEM_IPE_3    (-6893)
+%define VERR_NEM_IPE_4    (-6894)
+%define VERR_NEM_IPE_5    (-6895)
+%define VERR_NEM_IPE_6    (-6896)
+%define VERR_NEM_IPE_7    (-6897)
+%define VERR_NEM_IPE_8    (-6898)
+%define VERR_NEM_IPE_9    (-6899)
+%define VERR_RECORDING_CODEC_NOT_FOUND    (-6900)
+%define VERR_RECORDING_CODEC_INIT_FAILED    (-6902)
+%define VERR_RECORDING_CODEC_NOT_SUPPORTED    (-6903)
+%define VERR_RECORDING_FORMAT_NOT_SUPPORTED    (-6904)
+%define VERR_RECORDING_RESTRICTED    (-6905)
+%define VINF_RECORDING_LIMIT_REACHED    (6906)
+%define VERR_RECORDING_LIMIT_REACHED    (-6906)
+%define VINF_RECORDING_THROTTLED    (6907)
+%define VERR_RECORDING_THROTTLED    (-6907)
 %include "iprt/err.mac"